This URL creates the vIPS controller.
Resource URL
POST /cloud/<domain_id>/connector
Request Parameters
URL Parameters
| Field Name | Description | Data Type | Mandatory |
|---|---|---|---|
| Domain_Id | Domain id | Number | Yes |
Payload Parameters
| Field Name | Description | Data Type | Mandatory |
|---|---|---|---|
| name | Controller name | String | Yes |
| isHA | Specifies if the controller is in high availability mode or not | Boolean | Yes |
| serviceIp | Controller service IP, if provided | String | No |
| haTimeout | High availability timeout in minutes | Number | No |
| sharedSecret | Shared secret between the Manager and Controller | String | Yes |
| privateCommunicationSubnet | Private controller communication subnet CIDR | String | Yes |
| description | Controller description | String | No |
| cloud | Cloud access details | Object | Yes |
Details of fields in cloud:
| Field Name | Description | Data Type | Mandatory |
|---|---|---|---|
| type | Type of cloud environment. Supported value:
|
String | Yes |
| awsDetails | AWS cloud details | Object | Yes |
| azureDetails | Azure cloud details | Object | Yes |
Details of fields in AWS:
| Field Name | Description | Data Type | Mandatory |
|---|---|---|---|
| useIAMRole | Specifies if the IAM roles in Manager machines are used to access the AWS cloud or not | Boolean | Yes |
| region | Cloud access region | String | Yes |
| accessKey | Cloud access key | String | Yes |
| secretKey | Cloud access secret key | String | Yes |
Details of fields in Azure:
| Field Name | Description | Data Type | Mandatory |
|---|---|---|---|
| directoryId | Azure directory id | String | Yes |
| applicationKey | Azure app application key | String | Yes |
| applicationId | Azure app application id | String | Yes |
| subscription | Azure app subscription id | String | Yes |
Response Parameters
Following fields are returned if the request parameters are correct, otherwise error details are returned:
| Field Name | Description | Data Type |
|---|---|---|
| createdResourceId | Created resource id | Number |
Example
Request
POST https://<NSM_IP>/sdkapi/cloud/0/connector
Payload
{
'privateCommunicationSubnet': '1.1.1.0/24',
'sharedSecret': 'ControllerSharedSecretKey',
'name': 'Controller1',
‘isHA’: false,
"cloud":{
"azureDetails": {
"directoryId": "directoryId",
"applicationKey": "appKey",
"applicationId": "appId",
"subscription": "subscription"
},
"type": "AZURE",
"awsDetails": null
},
'description': 'Demo Controller'
}
Response
{
"createdResourceId" : 103
}
Error Information
Following error codes are returned by this URL:
| No | HTTP Error Code | SDK API errorId | SDK API errorMessage |
|---|---|---|---|
| 1 | 500 | 1001 | Internal error message: internal server error |
| 2 | 400 | 1105 | Invalid domain |
| 3 | 400 | 11001 | Name is required |
| 4 | 400 | 11001 | Controller name can have alphanumeric characters and [ _, -, . ] special characters |
| 5 | 400 | 11001 | Cloud details are required |
| 6 | 400 | 11001 | Cloud type is required |
| 7 | 400 | 11001 | Cloud type should be one of: <list of allowed values> |
| 8 | 400 | 11001 | Cloud region should be one of: <list of allowed regions> |
| 9 | 400 | 11001 | Shared secret is required |
| 10 | 400 | 11001 | Private communication subnet is required |
| 11 | 400 | 1701 | Invalid CIDR notation |
| 12 | 400 | 11001 | Only IPv4 IP supported for server IP address |
| 13 | 400 | 11001 | HA timeout should be between 1 and 10 |